﻿Option Strict On
Imports System.IO
Imports System.Windows.Forms

Public Class MieClassePersonaledll2
    'Struttura TipoQuery
    Public TipoParam As Integer = Nothing
    Public EQuer As New EnumQuery
    Public IdTab As Integer

    Public Class EnumQuery
        Public Const Insert As Integer = 0
        Public Const Update As Integer = 1
        Public Const Delete As Integer = 2
        Public Const SelectWithParameter As Integer = 3
        Public Const SelectWithoutParameter As Integer = 4
        Public Const DeleteAllRecords As Integer = 5
    End Class
    'Struttura Record
    Public Structure Record

        Public InsPrm As List(Of Integer)
        Public Valore As ArrayList

        ' constructor

        Public Sub New(ByVal Tp_prm As List(Of Integer), ByVal Valor As ArrayList)
            InsPrm = Tp_prm
            Valore = Valor
        End Sub 'New

        Public Property InsValue() As ArrayList
            Get
                Return Valore
            End Get
            Set(ByVal Value As ArrayList)
                Valore = Value
            End Set
        End Property
    End Structure
    Private Oledbcom As New OleDb.OleDbCommand
    Public Function LanciaQuery(ByVal ChiamataDaForm As String, ByVal ChiamataDaSub As String, ByVal StrutDaPassare As Record, _
                                ByVal TipoPrm As Integer, ByVal OleDbCon As OleDb.OleDbConnection, _
                                ByVal OleDbAdpt As OleDb.OleDbDataAdapter, _
                                ByVal ConnDB As String, ByVal Quer As String, _
                                Optional ByVal MsAfineAz As String = _
                                vbNullString) As Data.DataTable
        Try


            ScriviSuFile(ChiamataDaForm, ChiamataDaSub)

            Dim prm As New OleDb.OleDbParameter
            Dim dt As New System.Data.DataTable
            Dim ds As New System.Data.DataSet
            Oledbcom = New OleDb.OleDbCommand

            Select Case TipoPrm
                Case 0 To 2
                    Dim AzioneOk As Integer = 0
                    'Insert - 0 & Update - 1 & Delete - 2
                    LanciaParametri(prm, StrutDaPassare)

                    Oledbcom.CommandText = Quer
                    OleDbCon.ConnectionString = ConnDB
                    Oledbcom.Connection = OleDbCon
                    OleDbCon.Open()
                    AzioneOk = Oledbcom.ExecuteNonQuery()

                    OleDbCon.Close()

                    Beep()
                    If AzioneOk = 1 Then _
                    MessageBox.Show(MsAfineAz, MsAfineAz, MessageBoxButtons.OK, MessageBoxIcon.Information)

                    Return Nothing

                Case Is = EnumQuery.SelectWithParameter ' Select con Parametri
                    Dim AzioneOk As Integer = 0
                    Oledbcom = New OleDb.OleDbCommand
                    LanciaParametri(prm, StrutDaPassare)
                    OleDbAdpt = New OleDb.OleDbDataAdapter(Oledbcom)
                    OleDbAdpt.SelectCommand.CommandText = Quer
                    OleDbAdpt.SelectCommand.Connection = OleDbCon
                    OleDbCon.Open()
                    AzioneOk = OleDbAdpt.SelectCommand.ExecuteNonQuery()
                    OleDbAdpt.Fill(ds)

                    dt = ds.Tables(0)


                    Beep()
                    If AzioneOk = 1 Then _
                    MessageBox.Show(MsAfineAz, MsAfineAz, MessageBoxButtons.OK, MessageBoxIcon.Information)

                    OleDbCon.Close()
                    Return dt


                Case Is = EnumQuery.SelectWithoutParameter ' Select senza Parametri
                    Oledbcom = New OleDb.OleDbCommand
                    OleDbAdpt = New OleDb.OleDbDataAdapter

                    OleDbCon.ConnectionString = ConnDB
                    Oledbcom.CommandText = Quer

                    Oledbcom.Connection = OleDbCon
                    OleDbAdpt.SelectCommand = Oledbcom
                    OleDbCon.Open()

                    OleDbAdpt.Fill(ds)
                    dt = ds.Tables(0)
                    If dt.Rows Is Nothing OrElse dt.Rows.Count = 0 Then
                        MessageBox.Show("Nessun Record!", "Nessun Record!")
                        OleDbCon.Close()
                        Return Nothing
                    Else
                        IdTab = CType(dt.Rows(0).Item(0), Integer)
                        OleDbCon.Close()
                        Return dt
                    End If




                Case Is = EnumQuery.DeleteAllRecords 'Cancella tutti i Records
                    Dim AzioneOk As Integer = 0
                    OleDbCon.ConnectionString = ConnDB
                    Oledbcom = New OleDb.OleDbCommand   ' Inserisco il Record
                    Oledbcom.CommandText = Quer

                    Oledbcom.Connection = OleDbCon
                    OleDbCon.Open()
                    AzioneOk = Oledbcom.ExecuteNonQuery()
                    OleDbCon.Close()

                    Beep()
                    If AzioneOk = 1 Then _
                    MessageBox.Show(MsAfineAz, MsAfineAz, MessageBoxButtons.OK, MessageBoxIcon.Information)

                    Return Nothing

                Case Else
                    OleDbCon.Close()
                    Return Nothing
            End Select

        Catch ex As OleDb.OleDbException
            OleDbCon.Close()
            GestioneErrori(ex.Message, Err.Number)
            Return Nothing
        End Try

    End Function

    Private Sub LanciaParametri(ByVal Pr As OleDb.OleDbParameter, _
                                    ByVal StrutPassata As Record)

        Try

            Pr.Direction = ParameterDirection.Input
            Oledbcom = New OleDb.OleDbCommand

            For i As Integer = 0 To StrutPassata.Valore.Count - 1
                Select Case StrutPassata.InsPrm(i)
                    Case Is = DbType.String
                        Pr = New OleDb.OleDbParameter
                        Pr.DbType = DbType.String
                        Pr.Value = StrutPassata.Valore.Item(i)
                        Oledbcom.Parameters.Add(Pr)
                    Case Is = DbType.DateTime
                        Pr = New OleDb.OleDbParameter
                        Pr.DbType = DbType.DateTime
                        Pr.Value = StrutPassata.Valore.Item(i)
                        Oledbcom.Parameters.Add(Pr)
                    Case Is = DbType.Currency
                        Pr = New OleDb.OleDbParameter
                        Pr.DbType = DbType.Currency
                        Pr.Value = StrutPassata.Valore.Item(i)
                        Oledbcom.Parameters.Add(Pr)
                    Case Is = DbType.Boolean
                        Pr = New OleDb.OleDbParameter
                        Pr.DbType = DbType.Boolean
                        Pr.Value = StrutPassata.Valore.Item(i)
                        Oledbcom.Parameters.Add(Pr)
                    Case Is = DbType.Int32
                        Pr = New OleDb.OleDbParameter
                        Pr.DbType = DbType.Int32
                        Pr.Value = StrutPassata.Valore.Item(i)
                        Oledbcom.Parameters.Add(Pr)
                    Case Is = DbType.Object
                        Pr = New OleDb.OleDbParameter
                        Pr.DbType = DbType.Object
                        Pr.Value = StrutPassata.Valore.Item(i)
                        Oledbcom.Parameters.Add(Pr)
                    Case Else

                End Select

            Next

            Exit Sub

        Catch ex As Exception
            GestioneErrori(ex.Message, Err.Number)
            Exit Try
        End Try
    End Sub

    Private Sub ScriviSuFile(ByVal Frm As String, ByVal Sb As String)
        Try

            Dim FileLog As String = Microsoft.VisualBasic.FileIO.SpecialDirectories.MyDocuments & _
            "\FileLog.txt"
            Dim FileWriter As New StreamWriter(FileLog, True)
            FileWriter.WriteLine("Chiamato da Form: " & Frm & Space(2) & "e Sub/Function: " & Sb)
            FileWriter.Close()
            Exit Sub

        Catch ex As Exception
            GestioneErrori(ex.Message, Err.Number)
            Exit Try
        End Try
    End Sub

    Public Sub GestioneErrori(ByVal messErr As String, ByVal ErrNr As Integer)
        If ErrNr <> 0 Then _
        MessageBox.Show(messErr, "Errore nr.:" & ErrNr)
    End Sub

    Public Sub TrovaID(ByVal rcd As Record, _
                        ByVal Qry As String, ByVal connDb As String)

        Dim dt As New System.Data.DataTable
        Dim OledbCn As New OleDb.OleDbConnection
        Dim DaTrovVal As New ArrayList, TpPrm As New ArrayList
        Dim SetcnPrm As Integer = EnumQuery.SelectWithParameter


        Try

            OledbCn.ConnectionString = connDb

            Oledbcom = New OleDb.OleDbCommand(Qry, OledbCn)

            dt = LanciaQuery("MieClassePersonale", System.Reflection.MethodBase.GetCurrentMethod.Name, rcd, _
                                  SetcnPrm, OledbCn, New OleDb.OleDbDataAdapter, connDb, Qry, String.Empty)

            If dt.Rows.Count <> 0 Then
                IdTab = CType(dt.Rows(0).Item(0), Integer)
            End If

            Exit Sub

        Catch ex As Exception
            GestioneErrori(ex.Message, Err.Number)
            Exit Try
        End Try

    End Sub

    Public Function NrRecord(ByVal NrId As Integer, ByVal QueryConIndexTuttiRecord As String, ByVal conn_Db As String) As Integer
        Try
            'inizializzo tutti gli Oledb
            Dim OledbAdpt As New OleDb.OleDbDataAdapter
            Dim OledbCn As New OleDb.OleDbConnection
            Oledbcom = New OleDb.OleDbCommand
            Dim Agg As Integer = EnumQuery.SelectWithParameter
            Dim dt As New System.Data.DataTable
            Dim Insval2 As New ArrayList
            Dim tpPrm2 As New List(Of Integer)

            Insval2.Add(NrId) 'Int32  --- ID
            tpPrm2.Add(DbType.Int32)

            Dim Rcd As Record
            Rcd = New Record(tpPrm2, Insval2)
            OledbCn.ConnectionString = conn_Db

            dt = LanciaQuery("MieClassePersonale", System.Reflection.MethodBase.GetCurrentMethod.Name, Rcd, Agg, OledbCn, _
                             OledbAdpt, conn_Db, QueryConIndexTuttiRecord, "")


            For i As Integer = 0 To dt.Rows.Count - 1

                Dim risp As Integer
                risp = String.Compare(dt.Rows(i).Item(0).ToString, NrId.ToString)
                If risp = 0 Then
                    Return i + 1
                    Exit Function
                End If
            Next

        Catch ex As Exception
            GestioneErrori(ex.Message, Err.Number)
            Exit Try
        End Try

    End Function
    Public Enum TipoEstensione As Integer
        tutti = 0
        mdb = 1
        txt = 2
        jpeg = 3
        bmp = 4
        gif = 5
    End Enum
    Public Function CercaF(ByVal InitDDrct As String, ByVal FileDaCercare As String, _
                           ByVal Estensione As ArrayList) As String
        Dim cF As DialogResult
        Dim openfileDialog1 As New Windows.Forms.OpenFileDialog
        Dim Flt As String = String.Empty

        Try
            For i As Integer = 0 To Estensione.Count - 1
                Select Case DirectCast(Estensione(i), Integer)
                    Case TipoEstensione.tutti
                        Flt += "All files (*.*)|*.*"
                    Case TipoEstensione.mdb
                        Flt += "database (*.mdb)|*.mdb"
                    Case TipoEstensione.bmp
                        Flt += "Bmp (*.bmp)|*.bmp"
                    Case TipoEstensione.gif
                        Flt += "Gif (*.gif)|*.gif"
                    Case TipoEstensione.jpeg
                        Flt += "Jpeg (*.jpg)|*.jpg"
                    Case TipoEstensione.txt
                        Flt += "Text (*.txt)|*.txt"
                End Select

                If i <> Estensione.Count - 1 Then Flt += "|"
            Next

            With openfileDialog1
                .InitialDirectory = InitDDrct

                .Filter = Flt
                .FilterIndex = Estensione.Count
                .RestoreDirectory = True
                .FileName = FileDaCercare

                cF = .ShowDialog

                If cF = Windows.Forms.DialogResult.OK Then
                    Return openfileDialog1.FileName
                ElseIf cF = Windows.Forms.DialogResult.Cancel Then
                    Return vbNullString
                Else : Return vbNullString

                End If

            End With

        Catch ex As Exception
            GestioneErrori(ex.Message, Err.Number)
            Return String.Empty
            Exit Try
        End Try
    End Function


    Public Sub New()

    End Sub
End Class

Public Class SommaGGAn
    Structure SommaGG_Anno
        Public GGAnno As ArrayList
        Public SommaGGAnno As ArrayList


        Public Sub New( _
               ByVal GGAn As ArrayList, ByVal SmmGGAn As ArrayList)
            Me.GGAnno = GGAn
            Me.SommaGGAnno = SmmGGAn
        End Sub 'New

        Public Property InsGGAn() As ArrayList
            Get
                Return GGAnno
            End Get
            Set(ByVal Value As ArrayList)
                Me.GGAnno = Value
            End Set
        End Property

        Public Property InsSmGGAn() As ArrayList
            Get
                Return SommaGGAnno
            End Get
            Set(ByVal Value As ArrayList)
                Me.SommaGGAnno = Value
            End Set
        End Property

    End Structure
    Public Function SmmGGdellAnno(ByVal dt As DataTable, ByVal ColData As Integer, _
                                   ByVal ColSmGGAnno As Integer) As SommaGG_Anno

        Dim SommaGiorniAnno As New SommaGG_Anno
        Dim Somma As Decimal
        Dim SommaPerArr As New ArrayList
        Dim Data As Date
        Dim DataTabella As Date
        Dim GGAnTabella As Integer
        Dim GGAnn As Integer = Data.DayOfYear
        Dim GGAnnPerArr As New ArrayList
        Dim UgualeAggAnno As Boolean = True


        For i As Integer = 0 To dt.Rows.Count - 1

            If i = 0 Then
                GGAnn = Data.DayOfYear
                Data = CType(dt.Rows(i).Item(ColData), Date)
                GGAnn = Data.DayOfYear
            End If


            DataTabella = CType(dt.Rows(i).Item(ColData), Date)
            GGAnTabella = DataTabella.DayOfYear


            If GGAnn <> GGAnTabella Then
                UgualeAggAnno = False
            Else
                UgualeAggAnno = True
            End If


            If UgualeAggAnno Then
                Somma += CType(dt.Rows(i).Item(ColSmGGAnno), Decimal) 'sommo se stesso giorno
            Else
                'se no
                SommaPerArr.Add(Somma)
                GGAnnPerArr.Add(GGAnn)
                SommaGiorniAnno = New SommaGG_Anno(GGAnnPerArr, SommaPerArr) 'aggiungo somma nella struttura
                GGAnn = GGAnTabella    'nuovo giorno nella variabile
                Somma = CType(dt.Rows(i).Item(ColSmGGAnno), Decimal)   'somma reinizializzato
            End If

        Next

        Return SommaGiorniAnno

    End Function
    Public Sub New()

    End Sub
End Class
